/* ********************************************************
 * This file automatically generated by CmpFrame.pl.
 *                   Do not edit.                         *
 **********************************************************/

package uk.ac.starlink.ast;


/**
 * Java interface to the AST CmpFrame class
 *  - compound Frame. 
 * A CmpFrame is a compound Frame which allows two component Frames
 * (of any class) to be merged together to form a more complex
 * Frame. The axes of the two component Frames then appear together
 * in the resulting CmpFrame (those of the first Frame, followed by
 * those of the second Frame).
 * <p>
 * Since a CmpFrame is itself a Frame, it can be used as a
 * component in forming further CmpFrames. Frames of arbitrary
 * complexity may be built from simple individual Frames in this
 * way.
 * <p>
 * Also since a Frame is a Mapping, a CmpFrame can also be used as a
 * Mapping. Normally, a CmpFrame is simply equivalent to a UnitMap,
 * but if either of the component Frames within a CmpFrame is a Region
 * (a sub-class of Frame), then the CmpFrame will use the Region as a
 * Mapping when transforming values for axes described by the Region.
 * Thus input axis values corresponding to positions which are outside the
 * Region will result in bad output axis values.
 * <h4>Licence</h4>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public Licence as
 * published by the Free Software Foundation; either version 2 of
 * the Licence, or (at your option) any later version.
 * <p>
 * This program is distributed in the hope that it will be
 * useful,but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public Licence for more details.
 * <p>
 * You should have received a copy of the GNU General Public Licence
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street,Fifth Floor, Boston, MA
 * 02110-1301, USA
 * 
 * 
 * @see  <a href='http://star-www.rl.ac.uk/cgi-bin/htxserver/sun211.htx/?xref_CmpFrame'>AST CmpFrame</a>  
 */
public class CmpFrame extends Frame{
    /** 
     * Create a CmpFrame.   
     * @param  frame1  Pointer to the first component Frame.
     * 
     * @param  frame2  Pointer to the second component Frame.
     * 
     * @throws  AstException  if an error occurred in the AST library
    */
    public CmpFrame( Frame frame1, Frame frame2 ) {
        construct( frame1, frame2 );
    }
    private native void construct( Frame frame1, Frame frame2 );

    /**
     * Gets the component Frames from this CmpFrame.
     * This method returns pointers to two Frames which, when applied in
     * parallel, are equivalent to this CmpFrame.
     *
     * @return  a two-element array giving the component Frames
     * @throws  AstException  if an error occurs in the AST library
     */
    public Frame[] decompose() {
        Mapping[] frms = decompose( null, null );
        return new Frame[] { (Frame) frms[ 0 ], (Frame) frms[ 1 ] };
    }

}
