/* ********************************************************
 * This file automatically generated by ZoomMap.pl.
 *                   Do not edit.                         *
 **********************************************************/

package uk.ac.starlink.ast;


/**
 * Java interface to the AST ZoomMap class
 *  - zoom coordinates about the origin. 
 * The ZoomMap class implements a Mapping which performs a "zoom"
 * transformation by multiplying all coordinate values by the same
 * scale factor (the inverse transformation is performed by
 * dividing by this scale factor). The number of coordinate values
 * representing each point is unchanged.
 * <h4>Licence</h4>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public Licence as
 * published by the Free Software Foundation; either version 2 of
 * the Licence, or (at your option) any later version.
 * <p>
 * This program is distributed in the hope that it will be
 * useful,but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public Licence for more details.
 * <p>
 * You should have received a copy of the GNU General Public Licence
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street,Fifth Floor, Boston, MA
 * 02110-1301, USA
 * 
 * 
 * @see  <a href='http://star-www.rl.ac.uk/cgi-bin/htxserver/sun211.htx/?xref_ZoomMap'>AST ZoomMap</a>  
 */
public class ZoomMap extends Mapping {
    /** 
     * Creates a ZoomMap.   
     * @param  ncoord  The number of coordinate values for each point to be
     * transformed (i.e. the number of dimensions of the space in
     * which the points will reside). The same number is applicable
     * to both input and output points.
     * 
     * @param  zoom  Initial scale factor by which coordinate values should be
     * multiplied (by the forward transformation) or divided (by the
     * inverse transformation). This factor may subsequently be
     * changed via the ZoomMap's Zoom attribute. It may be positive
     * or negative, but should not be zero.
     * 
     * @throws  AstException  if an error occurred in the AST library
    */
    public ZoomMap( int ncoord, double zoom ) {
        construct( ncoord, zoom );
    }
    private native void construct( int ncoord, double zoom );

    /**
     * Get 
     * zoomMap scale factor.  
     * This attribute holds the ZoomMap scale factor, by which
     * coordinate values are multiplied (by the forward transformation)
     * or divided (by the inverse transformation). This factor is set
     * when a ZoomMap is created, but may later be modified. The
     * default value is unity.
     * <p>
     * Note that if a ZoomMap is inverted (e.g. by using astInvert),
     * then the reciprocal of this zoom factor will, in effect, be
     * used.
     * <h4>Notes</h4>
     * <br> - The Zoom attribute may not be set to zero.
     *
     * @return  this object's Zoom attribute
     */
    public double getZoom() {
        return getD( "Zoom" );
    }

    /**
     * Set 
     * zoomMap scale factor.  
     * This attribute holds the ZoomMap scale factor, by which
     * coordinate values are multiplied (by the forward transformation)
     * or divided (by the inverse transformation). This factor is set
     * when a ZoomMap is created, but may later be modified. The
     * default value is unity.
     * <p>
     * Note that if a ZoomMap is inverted (e.g. by using astInvert),
     * then the reciprocal of this zoom factor will, in effect, be
     * used.
     * <h4>Notes</h4>
     * <br> - The Zoom attribute may not be set to zero.
     *
     * @param  zoom   the Zoom attribute of this object
     */
    public void setZoom( double zoom ) {
       setD( "Zoom", zoom );
    }

}
